# Contributing to the code

If you find a problem with the code or have any ideas for new features or improvements, feel free to get involved! We ask that all problems are reported as [Github issues](https://github.com/ben-cassese/squishyplanet/issues) and all code changes are submitted as [pull requests](https://github.com/ben-cassese/squishyplanet/pulls) linked to an issue. Please make one branch per feature or bug fix, and be sure to include tests and Google-style [docstrings](https://google.github.io/styleguide/pyguide.html#383-functions-and-methods) for any major additions or changes.

If submitting a pull request, please be sure to run the tests (either with [tox](https://tox.wiki/en/latest/) or [pytest](https://docs.pytest.org/en/8.1.x/)) and to adhere to the [black](https://black.readthedocs.io/en/stable/) python code style. ``squishyplanet`` uses Github Actions for continuous integration, so all pull requests will automatically trigger tests and formatting checks.

Though ``squishyplanet`` is not affiliated with [Astropy](http://www.astropy.org/), we still ask that all contributors follow the [Astropy Project Code of Conduct](http://www.astropy.org/code_of_conduct.html). If you have any questions or concerns, please feel free to reach out to the maintainer(s).